#ifndef PROGRAM_H
#define PROGRAM_H

#include <GL/glew.h>
#include <cstdlib>

class Program{
public:
    void Initialize(const char* vertex_shader_file,
                    const char* fragment_shader_file,
                    const char* geometry_shader_file=NULL);
    operator GLuint() const{return program_;} // to be used in glUseFunction()
    ~Program();
private:
    GLuint program_;
    GLuint vertex_shader_;
    GLuint fragment_shader_;
    GLuint geometry_shader_;

    GLuint LoadAndCompileShaderOrDie(const char* source_file, GLenum type);
    GLuint LinkProgramOrDie(GLint vertex_shader, GLint fragment_shader, GLint geometry_shader=0);
};

#endif // PROGRAM_H
